diff --git a/src/modules/Extensions/YouTube.cpp b/src/modules/Extensions/YouTube.cpp
index 2812302f..8656faf0 100644
--- a/src/modules/Extensions/YouTube.cpp
+++ b/src/modules/Extensions/YouTube.cpp
@@ -21,20 +21,24 @@
 #include <YouTubeDL.hpp>
 #include <LineEdit.hpp>
 
-#include <QLoggingCategory>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
+    #include <QLoggingCategory>
+#else
+    #include <QDebug>
+#endif
 #include <QStringListModel>
 #include <QDesktopServices>
-#include <QJsonParseError>
+#include <QJsonParseError.h>
 #include <QActionGroup>
 #include <QTextDocument>
-#include <QJsonDocument>
+#include <QJsonDocument.h>
 #include <QProgressBar>
 #include <QApplication>
-#include <QJsonObject>
+#include <QJsonObject.h>
 #include <QHeaderView>
 #include <QGridLayout>
 #include <QToolButton>
-#include <QJsonArray>
+#include <QJsonArray.h>
 #include <QCompleter>
 #include <QClipboard>
 #include <QMimeData>
@@ -44,7 +48,12 @@
 #include <QMenu>
 #include <QUrl>
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
 Q_LOGGING_CATEGORY(youtube, "Extensions/YouTube")
+#else
+    #define qCWarning(category) qWarning() << #category ":"
+    #define qCDebug(category) qDebug() << #category ":"
+#endif
 
 #define YOUTUBE_URL "https://www.youtube.com"
 
@@ -90,8 +99,20 @@ ResultsYoutube::ResultsYoutube()
     headerItem()->setText(2, tr("User"));
 
     header()->setStretchLastSection(false);
-    header()->setSectionResizeMode(0, QHeaderView::Stretch);
-    header()->setSectionResizeMode(1, QHeaderView::ResizeToContents);
+    header()->
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+setSectionResizeMode(
+#else
+setResizeMode(
+#endif
+0, QHeaderView::Stretch);
+    header()->
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+setSectionResizeMode(
+#else
+setResizeMode(
+#endif
+1, QHeaderView::ResizeToContents);
 
     connect(this, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(playEntry(QTreeWidgetItem *)));
     connect(this, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(contextMenu(const QPoint &)));
@@ -139,6 +160,26 @@ void ResultsYoutube::showRelated()
     }
 }
 
+void ResultsYoutube::playAction()
+{
+    QAction *act = qobject_cast<QAction*>(sender());
+    if (act)
+    {
+        QString param = act->data().toString();
+        playOrEnqueue("open", currentItem(), param);
+    }
+}
+
+void ResultsYoutube::enqueueAction()
+{
+    QAction *act = qobject_cast<QAction*>(sender());
+    if (act)
+    {
+        QString param = act->data().toString();
+        playOrEnqueue("enqueue", currentItem(), param);
+    }
+}
+
 void ResultsYoutube::contextMenu(const QPoint &point)
 {
     QTreeWidgetItem *tWI = currentItem();
@@ -149,8 +190,7 @@ void ResultsYoutube::contextMenu(const QPoint &point)
     const QString url = tWI->data(0, Qt::UserRole).toString();
 
     auto menu = new QMenu(this);
-    connect(menu, &QMenu::aboutToHide,
-            menu, &QMenu::deleteLater);
+    connect(menu, SIGNAL(aboutToHide()), menu, SLOT(deleteLater()));
 
     for (int i = 0; i < 2; ++i)
     {
@@ -162,12 +202,14 @@ void ResultsYoutube::contextMenu(const QPoint &point)
         if (!tWI->isDisabled())
         {
             const auto param = i == 0 ? QString() : QString("audio");
-            subMenu->addAction(tr("Play"), this, [=] {
-                playOrEnqueue("open", currentItem(), param);
-            });
-            subMenu->addAction(tr("Enqueue"), this, [=] {
-                playOrEnqueue("enqueue", currentItem(), param);
-            });
+            QAction *playAct = subMenu->addAction(tr("Play"));
+            playAct->setData(param);
+            connect(playAct, SIGNAL(triggered()), this, SLOT(playAction()));
+
+            QAction *enqueueAct = subMenu->addAction(tr("Enqueue"));
+            enqueueAct->setData(param);
+            connect(enqueueAct, SIGNAL(triggered()), this, SLOT(enqueueAction()));
+
             subMenu->addSeparator();
         }
 
@@ -207,8 +249,7 @@ PageSwitcher::PageSwitcher(YouTube *youTubeW)
     currPageB = new QLabel;
 
     nextB = new QToolButton;
-    connect(nextB, &QToolButton::clicked,
-            youTubeW, &YouTube::chPage);
+    connect(nextB, SIGNAL(clicked()), youTubeW, SLOT(chPage()));
     nextB->setAutoRaise(true);
     nextB->setArrowType(Qt::RightArrow);
 
@@ -266,9 +307,7 @@ YouTube::YouTube(Module &module) :
     searchB->setAutoRaise(true);
 
     QToolButton *showSettingsB = new QToolButton;
-    connect(showSettingsB, &QToolButton::clicked, this, [] {
-        emit QMPlay2Core.showSettings("Extensions");
-    });
+    connect(showSettingsB, SIGNAL(clicked()), this, SLOT(showSettings()));
     showSettingsB->setIcon(QMPlay2Core.getIconFromTheme("configure"));
     showSettingsB->setToolTip(tr("Settings"));
     showSettingsB->setAutoRaise(true);
@@ -281,13 +320,9 @@ YouTube::YouTube(Module &module) :
     int qualityIdx = 0;
     for (QAction *act : m_qualityGroup->actions())
     {
-        connect(act, &QAction::triggered, this, [=] {
-            sets().set("YouTube/QualityPreset", act->text());
-        });
-        connect(act, &QAction::toggled, this, [=](bool checked) {
-            if (checked)
-                setItags(qualityIdx);
-        });
+        m_qualityActionToIndex[act] = qualityIdx;
+        connect(act, SIGNAL(triggered()), this, SLOT(onQualityActionTriggered()));
+        connect(act, SIGNAL(toggled(bool)), this, SLOT(onQualityActionToggled(bool)));
         act->setCheckable(true);
         qualityMenu->addAction(act);
         ++qualityIdx;
@@ -311,14 +346,8 @@ YouTube::YouTube(Module &module) :
     int sortByIdx = 0;
     for (QAction *act : m_sortByGroup->actions())
     {
-        connect(act, &QAction::triggered, this, [=] {
-            if (m_sortByIdx != sortByIdx)
-            {
-                m_sortByIdx = sortByIdx;
-                sets().set("YouTube/SortBy", m_sortByIdx);
-                search();
-            }
-        });
+        m_sortByActionToIndex[act] = sortByIdx;
+        connect(act, SIGNAL(triggered()), this, SLOT(onSortByActionTriggered()));
         act->setCheckable(true);
         sortByMenu->addAction(act);
         ++sortByIdx;
@@ -339,7 +368,7 @@ YouTube::YouTube(Module &module) :
     sortByB->setAutoRaise(true);
 
     resultsW = new ResultsYoutube;
-    connect(resultsW, &ResultsYoutube::requestRelated, this, &YouTube::fetchRelated);
+    connect(resultsW, SIGNAL(requestRelated(QString)), this, SLOT(fetchRelated(QString)));
 
     progressB = new QProgressBar;
     progressB->hide();
@@ -594,9 +623,22 @@ void YouTube::netFinished(NetworkReply *reply)
         }
         else if (reply == searchReply)
         {
-            m_apiKey = QRegularExpression(R"|("INNERTUBE_API_KEY"\s*:\s*"(.+?)")|").match(replyData).captured(1);
-            m_clientName = QRegularExpression(R"|("INNERTUBE_CLIENT_NAME"\s*:\s*"(.+?)")|").match(replyData).captured(1);
-            m_clientVersion = QRegularExpression(R"|("INNERTUBE_CLIENT_VERSION"\s*:\s*"(.+?)")|").match(replyData).captured(1);
+            // Qt4: Use QRegExp instead of QRegularExpression
+            QRegExp apiKeyRe("\"INNERTUBE_API_KEY\"\\s*:\\s*\"(.+?)\"");
+            apiKeyRe.setMinimal(true);
+            if (apiKeyRe.indexIn(replyData) != -1)
+                m_apiKey = apiKeyRe.cap(1);
+
+            QRegExp clientNameRe("\"INNERTUBE_CLIENT_NAME\"\\s*:\\s*\"(.+?)\"");
+            clientNameRe.setMinimal(true);
+            if (clientNameRe.indexIn(replyData) != -1)
+                m_clientName = clientNameRe.cap(1);
+
+            QRegExp clientVersionRe("\"INNERTUBE_CLIENT_VERSION\"\\s*:\\s*\"(.+?)\"");
+            clientVersionRe.setMinimal(true);
+            if (clientVersionRe.indexIn(replyData) != -1)
+                m_clientVersion = clientVersionRe.cap(1);
+
             setSearchResults(getYtInitialData(replyData).object(), false, false);
         }
         else if (reply == relatedReply)
@@ -988,52 +1030,48 @@ void YouTube::setSearchResults(const QJsonObject &jsonObj, bool isContinuation,
     {
         Q_ASSERT(!isContinuation);
 
-        items = jsonObj
-            ["contents"]
-            ["twoColumnWatchNextResults"]
-            ["secondaryResults"]
-            ["secondaryResults"]
-            ["results"].toArray()
-        ;
+        const QJsonObject contents = jsonObj["contents"].toObject();
+        const QJsonObject twoColumnWatchNextResults = contents["twoColumnWatchNextResults"].toObject();
+        const QJsonObject secondaryResults1 = twoColumnWatchNextResults["secondaryResults"].toObject();
+        const QJsonObject secondaryResults2 = secondaryResults1["secondaryResults"].toObject();
+        items = secondaryResults2["results"].toArray();
     }
     else if (isContinuation)
     {
         const auto onResponseReceivedCommands = jsonObj
             ["onResponseReceivedCommands"].toArray()
         ;
-        for (const QJsonValue val : onResponseReceivedCommands)
+        for (const QJsonValue &val : onResponseReceivedCommands)
         {
-            items = val
-                ["appendContinuationItemsAction"]
-                ["continuationItems"].toArray()
-            ;
+            const QJsonObject valObj = val.toObject();
+            const QJsonObject appendContinuationItemsAction = valObj["appendContinuationItemsAction"].toObject();
+            items = appendContinuationItemsAction["continuationItems"].toArray();
             if (!items.isEmpty())
                 break;
         }
     }
     else
     {
-        items = jsonObj
-            ["contents"]
-            ["twoColumnSearchResultsRenderer"]
-            ["primaryContents"]
-            ["sectionListRenderer"]
-            ["contents"].toArray()
-        ;
+        const QJsonObject contents = jsonObj["contents"].toObject();
+        const QJsonObject twoColumnSearchResultsRenderer = contents["twoColumnSearchResultsRenderer"].toObject();
+        const QJsonObject primaryContents = twoColumnSearchResultsRenderer["primaryContents"].toObject();
+        const QJsonObject sectionListRenderer = primaryContents["sectionListRenderer"].toObject();
+        items = sectionListRenderer["contents"].toArray();
     }
 
-    for (const QJsonValue obj : items)
+    for (const QJsonValue &obj : items)
     {
         if (isRelatedResults)
         {
             bool radioRenderer = false;
 
-            const auto videoRenderer = obj["compactVideoRenderer"].toObject();
+            const QJsonObject objObj = obj.toObject();
+            const auto videoRenderer = objObj["compactVideoRenderer"].toObject();
             const auto playlistRenderer = [&] {
-                auto r = obj["compactPlaylistRenderer"].toObject();
+                auto r = objObj["compactPlaylistRenderer"].toObject();
                 if (r.isEmpty())
                 {
-                    r = obj["compactRadioRenderer"].toObject();
+                    r = objObj["compactRadioRenderer"].toObject();
                     radioRenderer = !r.isEmpty();
                 }
                 return r;
@@ -1043,16 +1081,20 @@ void YouTube::setSearchResults(const QJsonObject &jsonObj, bool isContinuation,
 
             if (isVideo)
             {
-                title = videoRenderer["title"]["simpleText"].toString();
+                title = videoRenderer["title"].toObject()["simpleText"].toString();
                 contentId = videoRenderer["videoId"].toString();
                 if (title.isEmpty() || contentId.isEmpty())
                     continue;
 
-                length = videoRenderer["lengthText"]["simpleText"].toString();
-                user = videoRenderer["longBylineText"]["runs"].toArray().at(0)["text"].toString();
-                publishTime = videoRenderer["publishedTimeText"]["simpleText"].toString();
-                viewCount = videoRenderer["shortViewCountText"]["simpleText"].toString();
-                thumbnail = videoRenderer["thumbnail"]["thumbnails"].toArray().at(0)["url"].toString();
+                length = videoRenderer["lengthText"].toObject()["simpleText"].toString();
+                const QJsonArray longBylineTextRuns = videoRenderer["longBylineText"].toObject()["runs"].toArray();
+                if (!longBylineTextRuns.isEmpty())
+                    user = longBylineTextRuns.at(0).toObject()["text"].toString();
+                publishTime = videoRenderer["publishedTimeText"].toObject()["simpleText"].toString();
+                viewCount = videoRenderer["shortViewCountText"].toObject()["simpleText"].toString();
+                const QJsonArray thumbnailsArray = videoRenderer["thumbnail"].toObject()["thumbnails"].toArray();
+                if (!thumbnailsArray.isEmpty())
+                    thumbnail = thumbnailsArray.at(0).toObject()["url"].toString();
 
                 url = YOUTUBE_URL "/watch?v=" + contentId;
             }
@@ -1060,22 +1102,25 @@ void YouTube::setSearchResults(const QJsonObject &jsonObj, bool isContinuation,
             {
                 QString videoId;
 
-                title = playlistRenderer["title"]["simpleText"].toString();
+                title = playlistRenderer["title"].toObject()["simpleText"].toString();
                 contentId = playlistRenderer["playlistId"].toString();
                 if (title.isEmpty() || contentId.isEmpty())
                     continue;
 
                 if (radioRenderer)
                 {
-                    videoId = playlistRenderer["navigationEndpoint"]["watchEndpoint"]["videoId"].toString();
+                    const QJsonObject navigationEndpoint = playlistRenderer["navigationEndpoint"].toObject();
+                    videoId = navigationEndpoint["watchEndpoint"].toObject()["videoId"].toString();
                     if (videoId.isEmpty())
                         continue;
                 }
                 else
                 {
-                    user = playlistRenderer["longBylineText"]["simpleText"].toString();
+                    user = playlistRenderer["longBylineText"].toObject()["simpleText"].toString();
                 }
-                thumbnail = playlistRenderer["thumbnail"]["thumbnails"].toArray().at(0)["url"].toString();
+                const QJsonArray thumbnailsArray = playlistRenderer["thumbnail"].toObject()["thumbnails"].toArray();
+                if (!thumbnailsArray.isEmpty())
+                    thumbnail = thumbnailsArray.at(0).toObject()["url"].toString();
 
                 if (radioRenderer)
                     url = YOUTUBE_URL "/watch?v=" + videoId + "&list=" + contentId;
@@ -1087,25 +1132,23 @@ void YouTube::setSearchResults(const QJsonObject &jsonObj, bool isContinuation,
         }
         else
         {
-            const auto contents = obj
-                ["itemSectionRenderer"]
-                ["contents"].toArray()
-            ;
-
-            const auto token = obj
-                ["continuationItemRenderer"]
-                ["continuationEndpoint"]
-                ["continuationCommand"]
-                ["token"].toString()
-            ;
+            const QJsonObject objObj = obj.toObject();
+            const QJsonObject itemSectionRenderer = objObj["itemSectionRenderer"].toObject();
+            const auto contents = itemSectionRenderer["contents"].toArray();
+
+            const QJsonObject continuationItemRenderer = objObj["continuationItemRenderer"].toObject();
+            const QJsonObject continuationEndpoint = continuationItemRenderer["continuationEndpoint"].toObject();
+            const QJsonObject continuationCommand = continuationEndpoint["continuationCommand"].toObject();
+            const auto token = continuationCommand["token"].toString();
             if (!token.isEmpty())
                 m_continuationToken = token;
 
-            for (const QJsonValue obj : contents)
+            for (const QJsonValue &objVal : contents)
             {
                 bool radioRenderer = false;
                 bool lockupViewModel = false;
 
+                const QJsonObject obj = objVal.toObject();
                 const auto videoRenderer = obj["videoRenderer"].toObject();
                 const auto playlistRenderer = [&] {
                     auto r = obj["playlistRenderer"].toObject();
@@ -1126,16 +1169,22 @@ void YouTube::setSearchResults(const QJsonObject &jsonObj, bool isContinuation,
 
                 if (isVideo)
                 {
-                    title = videoRenderer["title"]["runs"].toArray().at(0)["text"].toString();
+                    const QJsonArray titleRuns = videoRenderer["title"].toObject()["runs"].toArray();
+                    if (!titleRuns.isEmpty())
+                        title = titleRuns.at(0).toObject()["text"].toString();
                     contentId = videoRenderer["videoId"].toString();
                     if (title.isEmpty() || contentId.isEmpty())
                         continue;
 
-                    length = videoRenderer["lengthText"]["simpleText"].toString();
-                    user = videoRenderer["ownerText"]["runs"].toArray().at(0)["text"].toString();
-                    publishTime = videoRenderer["publishedTimeText"]["simpleText"].toString();
-                    viewCount = videoRenderer["shortViewCountText"]["simpleText"].toString();
-                    thumbnail = videoRenderer["thumbnail"]["thumbnails"].toArray().at(0)["url"].toString();
+                    length = videoRenderer["lengthText"].toObject()["simpleText"].toString();
+                    const QJsonArray ownerTextRuns = videoRenderer["ownerText"].toObject()["runs"].toArray();
+                    if (!ownerTextRuns.isEmpty())
+                        user = ownerTextRuns.at(0).toObject()["text"].toString();
+                    publishTime = videoRenderer["publishedTimeText"].toObject()["simpleText"].toString();
+                    viewCount = videoRenderer["shortViewCountText"].toObject()["simpleText"].toString();
+                    const QJsonArray thumbnailsArray = videoRenderer["thumbnail"].toObject()["thumbnails"].toArray();
+                    if (!thumbnailsArray.isEmpty())
+                        thumbnail = thumbnailsArray.at(0).toObject()["url"].toString();
 
                     url = YOUTUBE_URL "/watch?v=" + contentId;
                 }
@@ -1143,22 +1192,28 @@ void YouTube::setSearchResults(const QJsonObject &jsonObj, bool isContinuation,
                 {
                     QString videoId;
 
-                    title = playlistRenderer["metadata"]["lockupMetadataViewModel"]["title"]["content"].toString();
-                    contentId = playlistRenderer["rendererContext"]["commandContext"]["onTap"]["innertubeCommand"]["watchEndpoint"]["playlistId"].toString();
-                    videoId = playlistRenderer["rendererContext"]["commandContext"]["onTap"]["innertubeCommand"]["watchEndpoint"]["videoId"].toString();
+                    const QJsonObject metadata = playlistRenderer["metadata"].toObject();
+                    const QJsonObject lockupMetadataViewModel = metadata["lockupMetadataViewModel"].toObject();
+                    title = lockupMetadataViewModel["title"].toObject()["content"].toString();
+
+                    const QJsonObject rendererContext = playlistRenderer["rendererContext"].toObject();
+                    const QJsonObject commandContext = rendererContext["commandContext"].toObject();
+                    const QJsonObject onTap = commandContext["onTap"].toObject();
+                    const QJsonObject innertubeCommand = onTap["innertubeCommand"].toObject();
+                    const QJsonObject watchEndpoint = innertubeCommand["watchEndpoint"].toObject();
+                    contentId = watchEndpoint["playlistId"].toString();
+                    videoId = watchEndpoint["videoId"].toString();
                     if (title.isEmpty() || contentId.isEmpty() || videoId.isEmpty())
                         continue;
 
-                    const auto thumbnails = playlistRenderer
-                        ["contentImage"]
-                        ["collectionThumbnailViewModel"]
-                        ["primaryThumbnail"]
-                        ["thumbnailViewModel"]
-                        ["image"]
-                        ["sources"].toArray()
-                    ;
+                    const QJsonObject contentImage = playlistRenderer["contentImage"].toObject();
+                    const QJsonObject collectionThumbnailViewModel = contentImage["collectionThumbnailViewModel"].toObject();
+                    const QJsonObject primaryThumbnail = collectionThumbnailViewModel["primaryThumbnail"].toObject();
+                    const QJsonObject thumbnailViewModel = primaryThumbnail["thumbnailViewModel"].toObject();
+                    const QJsonObject image = thumbnailViewModel["image"].toObject();
+                    const auto thumbnails = image["sources"].toArray();
                     if (!thumbnails.isEmpty())
-                        thumbnail = thumbnails[0]["url"].toString();
+                        thumbnail = thumbnails[0].toObject()["url"].toString();
 
                     url = YOUTUBE_URL "/watch?v=" + videoId + "&list=" + contentId;
                 }
@@ -1166,28 +1221,31 @@ void YouTube::setSearchResults(const QJsonObject &jsonObj, bool isContinuation,
                 {
                     QString videoId;
 
-                    title = playlistRenderer["title"]["simpleText"].toString();
+                    title = playlistRenderer["title"].toObject()["simpleText"].toString();
                     contentId = playlistRenderer["playlistId"].toString();
                     if (title.isEmpty() || contentId.isEmpty())
                         continue;
 
                     if (radioRenderer)
                     {
-                        videoId = playlistRenderer["navigationEndpoint"]["watchEndpoint"]["videoId"].toString();
+                        const QJsonObject navigationEndpoint = playlistRenderer["navigationEndpoint"].toObject();
+                        videoId = navigationEndpoint["watchEndpoint"].toObject()["videoId"].toString();
                         if (videoId.isEmpty())
                             continue;
                     }
                     else
                     {
-                        user = playlistRenderer["longBylineText"]["runs"].toArray().at(0)["text"].toString();
+                        const QJsonArray longBylineTextRuns = playlistRenderer["longBylineText"].toObject()["runs"].toArray();
+                        if (!longBylineTextRuns.isEmpty())
+                            user = longBylineTextRuns.at(0).toObject()["text"].toString();
                     }
-                    thumbnail = playlistRenderer
-                        ["thumbnailRenderer"]
-                        ["playlistVideoThumbnailRenderer"]
-                        ["thumbnail"]
-                        ["thumbnails"].toArray().at(0)
-                        ["url"].toString()
-                    ;
+
+                    const QJsonObject thumbnailRenderer = playlistRenderer["thumbnailRenderer"].toObject();
+                    const QJsonObject playlistVideoThumbnailRenderer = thumbnailRenderer["playlistVideoThumbnailRenderer"].toObject();
+                    const QJsonObject thumbnailObj = playlistVideoThumbnailRenderer["thumbnail"].toObject();
+                    const QJsonArray thumbnailsArray = thumbnailObj["thumbnails"].toArray();
+                    if (!thumbnailsArray.isEmpty())
+                        thumbnail = thumbnailsArray.at(0).toObject()["url"].toString();
 
                     if (radioRenderer)
                         url = YOUTUBE_URL "/watch?v=" + videoId + "&list=" + contentId;
@@ -1236,7 +1294,7 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
     const bool hasTitle = !rawErrOutput.contains("Unable to extract video title", Qt::CaseInsensitive);
     const auto title = hasTitle ? o["title"].toString() : QString();
 
-    if (hasTitle && o["_type"].toString() == QStringLiteral("playlist"))
+    if (hasTitle && o["_type"].toString() == QString("playlist"))
     {
         PlaylistEntries entries;
         for (const QJsonValue &entryVal : o["entries"].toArray())
@@ -1285,17 +1343,17 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
         }
 
         const auto itagStr = format["format_id"].toString().split('-');
-        const auto note = format[QStringLiteral("format_note")].toString();
+        const auto note = format[QString("format_note")].toString();
         const auto itag = itagStr.value(0).toInt();
         const auto url = format["url"].toString();
         const auto ext = format["ext"].toString();
-        if (itag != 0 && !url.isEmpty() && !ext.isEmpty() && (!note.contains(QStringLiteral("DRC")) || sets().getBool(QStringLiteral("YouTube/AllowDRC"))))
+        if (itag != 0 && !url.isEmpty() && !ext.isEmpty() && (!note.contains(QString("DRC")) || sets().getBool(QString("YouTube/AllowDRC"))))
         {
             itagsData[itag].first += url;
             itagsData[itag].second += "." + ext;
             if (audioItags.contains(itag))
             {
-                urlLanguages[url] = format[QStringLiteral("language")].toString();
+                urlLanguages[url] = format[QString("language")].toString();
                 urlNotes[url] = note;
             }
         }
@@ -1305,7 +1363,7 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
         for (auto &&itag : itags)
         {
             auto it = itagsData.constFind(itag);
-            if (it != itagsData.cend())
+            if (it != itagsData.constEnd())
             {
                 urls += it->first;
                 exts += it->second;
@@ -1361,7 +1419,7 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
         if (subtitlesForLang.isEmpty())
             subtitlesForLang = subtitles["en"].toArray();
 
-        for (auto &&subtitlesFmtVal : std::as_const(subtitlesForLang))
+        for (auto &&subtitlesFmtVal : subtitlesForLang)
         {
             const auto subtitlesFmt = subtitlesFmtVal.toObject();
             if (subtitlesFmt.isEmpty())
@@ -1384,22 +1442,22 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
     Q_ASSERT(!urls.isEmpty());
     Q_ASSERT(urls.count() == exts.count());
 
-    for (auto &&url : std::as_const(urls))
+    for (auto &&url : urls)
     {
         const auto urlNote = urlNotes.value(url).trimmed();
         const auto urlLanguage = urlLanguages.value(url).trimmed();
         QList<QMPlay2Tag> tags;
         if (!urlNote.isEmpty())
         {
-            tags += {{QString::number(QMPLAY2_TAG_DEFAULT), QString::number(urlNote.contains(QStringLiteral("(default)")))}};
-            if (urlNote.contains(QStringLiteral("DRC")))
+            tags += {{QString::number(QMPLAY2_TAG_DEFAULT), QString::number(urlNote.contains(QString("(default)")) ? 1 : 0)}};
+            if (urlNote.contains(QString("DRC")))
                 tags += {{QString::number(QMPLAY2_TAG_DRC), tr("yes")}};
         }
         if (!urlLanguage.isEmpty())
         {
             QString lang;
-            const int idx1 = urlLanguage.indexOf(QStringLiteral(","));
-            const int idx2 = urlLanguage.indexOf(QStringLiteral(" "));
+            const int idx1 = urlLanguage.indexOf(QString(","));
+            const int idx2 = urlLanguage.indexOf(QString(" "));
             int idx = qMin(idx1, idx2);
             if (idx < 0)
                 idx = qMax(idx1, idx2);
@@ -1421,12 +1479,12 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
     else
     {
         QString url = "FFmpeg://{";
-        for (auto &&urlPart : std::as_const(urls))
+        for (auto &&urlPart : urls)
             url += "[" + urlPart + "]";
         url += "}";
 
         QString ext;
-        for (auto &&extPart : std::as_const(exts))
+        for (auto &&extPart : exts)
             ext += "[" + extPart + "]";
 
         result += url;
@@ -1460,3 +1518,48 @@ QJsonDocument YouTube::getYtInitialData(const QByteArray &data)
 
     return QJsonDocument();
 }
+
+void YouTube::showSettings()
+{
+    emit QMPlay2Core.showSettings("Extensions");
+}
+
+void YouTube::onQualityActionTriggered()
+{
+    QAction *act = qobject_cast<QAction*>(sender());
+    if (act)
+        sets().set("YouTube/QualityPreset", act->text());
+}
+
+void YouTube::onQualityActionToggled(bool checked)
+{
+    if (!checked)
+        return;
+
+    QAction *act = qobject_cast<QAction*>(sender());
+    if (act)
+    {
+        auto it = m_qualityActionToIndex.find(act);
+        if (it != m_qualityActionToIndex.end())
+            setItags(it.value());
+    }
+}
+
+void YouTube::onSortByActionTriggered()
+{
+    QAction *act = qobject_cast<QAction*>(sender());
+    if (act)
+    {
+        auto it = m_sortByActionToIndex.find(act);
+        if (it != m_sortByActionToIndex.end())
+        {
+            int sortByIdx = it.value();
+            if (m_sortByIdx != sortByIdx)
+            {
+                m_sortByIdx = sortByIdx;
+                sets().set("YouTube/SortBy", m_sortByIdx);
+                search();
+            }
+        }
+    }
+}
